/*{{{  decls*/
#include <stdio.h>
#include "symbol.h"	/* for decl of 'emalloc()' */

#define STDIO_H

typedef struct Data {
	char  *buf;
	struct Data  *next;
} Data;

Data  *first_datap,  *last_datap;

/*}}}*/
/*{{{  char *new_databuf (char *s)*/
char *new_databuf (s)
/*-----------------*/
	char *s;
/*------------------------------------------------------*/
/*	Allocate a new data buffer to store the DATA	*/
/*  statement specification '*s', and attach it to the	*/
/*  end of the linked list.				*/
/*------------------------------------------------------*/
{
	Data  *datap;

	datap = (Data *) emalloc (sizeof (Data));
	datap->buf = s;

	/*----------------------------*/
	/*  attach to 'databuf' list  */
	/*----------------------------*/
	if (first_datap == NULL)
		first_datap = last_datap = datap;
	else {
		last_datap->next = datap;
		last_datap = datap;
	}
}
/*}}}*/
/*{{{  clear_databuf ()*/
clear_databuf ()
/*------------*/
/*--------------------------------------*/
/*	Delete all the data buffers.	*/
/*--------------------------------------*/
{
	Data  *datap, *nextdata;

	for (datap = first_datap;  datap;  datap = nextdata) {
		nextdata = datap->next;
		free (datap->buf);
		free ((char *) datap);
	}
	first_datap = NULL;
}

/*}}}*/

